package fr.jelora.TeleinformationEDF;

import org.junit.Test;

public class TestChecksum {

	@Test
	public void test() {
		String ligne = "PTEC HP..  ";
		
		System.out.println("Result: " + verifChecksum(ligne));
	}
	
	private boolean verifChecksum(String ligne){
		if ( ligne.length() > 2 ){
			String ligneContenu = ligne.substring(0, ligne.length()-2);
			char checksumLigne = ligne.charAt(ligne.length()-1);
			
			int sum = 0;
			for ( int i = 0 ; i < ligneContenu.length() ; i++ ){
				sum += ligneContenu.charAt(i);
			}
			sum = sum & 0x3F;
			sum += 0x20;
			
			System.out.println("LIGNE: \"" + ligneContenu + "\"");
			System.out.println("Checksum: " + (int) checksumLigne);
			System.out.println("Checksum vérif: " + (int) sum);
			if ( sum == checksumLigne ){
				return true;
			}
			else{
				return false;
			}
		}
		else{
			return false;
		}
	}
}
